Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1517006 - Review Request: vimiv - An image viewer with vim-like keybindings
Summary: Review Request: vimiv - An image viewer with vim-like keybindings
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Christoph Junghans
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-11-23 21:21 UTC by Ankur Sinha (FranciscoD)
Modified: 2017-12-28 02:48 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-26 16:29:55 UTC
junghans: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2017-11-23 21:21:37 UTC
Spec URL: https://ankursinha.fedorapeople.org/vimiv/vimiv.spec
SRPM URL: https://ankursinha.fedorapeople.org/vimiv/vimiv-0.9.1-1.fc27.src.rpm

Description: 
Vimiv is an image viewer with vim-like keybindings. It is written in python3
using the Gtk3 toolkit. Some of the features are:

- Thumbnail mode
- Simple library browser
- Basic image editing
- Command line with tab completion


Fedora Account System Username: ankursinha

There's a COPR for people to try out the package here:
https://copr.fedorainfracloud.org/coprs/ankursinha/vimiv/

Comment 1 Sergey Avseyev 2017-11-24 10:39:38 UTC
Shall it have recommended dependency on python3-gexiv2? I've noticed that it tries to import it in runtime: https://github.com/karlch/vimiv/blob/cedbeac80e89f21f67962976716823aea58451eb/vimiv/imageactions.py#L13

Comment 2 Sergey Avseyev 2017-11-24 10:46:42 UTC
It should not have 755 mode on manpages and appdata.xml

Also binary dependency libgexiv2 will be picked up implicitly (if you include python3-gexiv2)

Comment 3 Ankur Sinha (FranciscoD) 2017-11-24 13:19:20 UTC
Thanks for the comments, Sergey. Updated:

Spec URL: https://ankursinha.fedorapeople.org/vimiv/vimiv.spec
SRPM URL: https://ankursinha.fedorapeople.org/vimiv/vimiv-0.9.1-2.fc27.src.rpm

New builds are ready on copr for testing too.

Cheers!
Ankur

Comment 4 Sergey Avseyev 2017-11-24 13:42:01 UTC
Could you also update all python dependencies to new format[1]? 

  Requires: %{py3_dist gexiv2}

But in general it looks good to me.

[1]: https://fedoraproject.org/wiki/Packaging:Python#Requires_and_BuildRequires_with_standardized_names

Comment 5 Ankur Sinha (FranciscoD) 2017-11-24 14:16:10 UTC
I wasn't aware of these new macros, and it does look like they're not respected by all packages just yet:

[asinha@cs-as14aho-2-herts-ac-uk  ~]$ rpm -q --provides python3-setuptools
python3-setuptools = 36.2.0-7.fc27
python3.6dist(setuptools) = 36.2.0
python3dist(setuptools) = 36.2.0

[asinha@cs-as14aho-2-herts-ac-uk  ~]$ rpm -q --provides python3-gexiv2
libgexiv2-python3 = libgexiv2-0.10.6
python3-gexiv2 = 0.10.6-3.fc27
python3-gexiv2(x86-64) = 0.10.6-3.fc27

[asinha@cs-as14aho-2-herts-ac-uk  ~]$ rpm -q --provides python3-gobject
python3-gobject = 3.26.1-1.fc27
python3-gobject(x86-64) = 3.26.1-1.fc27


asinha@cs-as14aho-2-herts-ac-uk  ~]$ sudo dnf install 'python3dist(gexiv2)'
[sudo] password for asinha: 
Last metadata expiration check: 0:29:56 ago on Fri 24 Nov 2017 13:39:26 GMT.
No match for argument: python3dist(gexiv2)
Error: Unable to find a match

[asinha@cs-as14aho-2-herts-ac-uk  ~]$ sudo dnf install 'python3dist(libgexiv2)'
Last metadata expiration check: 0:30:46 ago on Fri 24 Nov 2017 13:39:26 GMT.
No match for argument: python3dist(libgexiv2)
Error: Unable to find a match

[asinha@cs-as14aho-2-herts-ac-uk  ~]$ sudo dnf install 'python3dist(gexiv)'
Last metadata expiration check: 0:30:54 ago on Fri 24 Nov 2017 13:39:26 GMT.
No match for argument: python3dist(gexiv)
Error: Unable to find a match

etc. Leaving it as is for the time being.

Thanks,
Ankur

Comment 6 Sergey Avseyev 2017-11-24 14:26:28 UTC
This macro accessible starting from Fedora 26, do you target old releases? It should be just expanded to python3-gexiv2, so I don't think it will be recorded as is in the resulting RPM.

Comment 7 Ankur Sinha (FranciscoD) 2017-11-24 14:55:54 UTC
Well, as you see from the commands in my comment, on an F27 system, it is recorded in setuptools, and so it works there, but it isn't in the other two packages and fails---also causing all my copr builds to fail :(

Comment 8 Christoph Junghans 2017-11-25 16:14:45 UTC
Thanks @Sergey for looking for it! I had a look as well!


Summary:
=======
I found (nitpicks):
- there are tests in tests/, can we run these in %check?
- Can you use install -p to preserve timestamps?
and fedora-review found, which is ok already:
- update-desktop-database is invoked in %post and %postun if package
  contains desktop file(s) with a MimeType: entry.
  Note: desktop file(s) with MimeType entry in vimiv
  See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#desktop-
  database
rpmlist found:
- invalid-url URL: http://karlch.github.io/vimiv, but works for me

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[-]: Package does not contain kernel modules.
[-]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 96 files have
     unknown license. Detailed output of licensecheck in
     /home/junghans/review/review-vimiv/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: vimiv-0.9.1-2.fc27.x86_64.rpm
          vimiv-debuginfo-0.9.1-2.fc27.x86_64.rpm
          vimiv-0.9.1-2.fc27.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (debuginfo)
-------------------
Checking: vimiv-debuginfo-0.9.1-2.fc27.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
vimiv-debuginfo.x86_64: W: invalid-url URL: http://karlch.github.io/vimiv <urlopen error [Errno -2] Name or service not known>
vimiv.x86_64: W: invalid-url URL: http://karlch.github.io/vimiv <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
vimiv-debuginfo (rpmlib, GLIBC filtered):

vimiv (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/python3
    config(vimiv)
    gtk3
    hicolor-icon-theme
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython3.6m.so.1.0()(64bit)
    python(abi)
    python3-gexiv2
    rtld(GNU_HASH)



Provides
--------
vimiv-debuginfo:
    debuginfo(build-id)
    vimiv-debuginfo
    vimiv-debuginfo(x86-64)

vimiv:
    application()
    application(vimiv.desktop)
    config(vimiv)
    mimehandler(image/bmp)
    mimehandler(image/gif)
    mimehandler(image/jp2)
    mimehandler(image/jpeg)
    mimehandler(image/jpeg2000)
    mimehandler(image/jpx)
    mimehandler(image/png)
    mimehandler(image/svg)
    mimehandler(image/tiff)
    python3.6dist(vimiv)
    python3dist(vimiv)
    vimiv
    vimiv(x86-64)



Unversioned so-files
--------------------
vimiv: /usr/lib64/python3.6/site-packages/vimiv/_image_enhance.cpython-36m-x86_64-linux-gnu.so

Source checksums
----------------
https://github.com/karlch/vimiv/archive/v0.9.1/vimiv-0.9.1.tar.gz :
  CHECKSUM(SHA256) this package     : 7196341c41ad372f4d5d98bc96fba4aa55ad6e78d93afd617a62866bdaa6c087
  CHECKSUM(SHA256) upstream package : 7196341c41ad372f4d5d98bc96fba4aa55ad6e78d93afd617a62866bdaa6c087


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -v --mock-config fedora-rawhide-x86_64 -n vimiv
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 9 Ankur Sinha (FranciscoD) 2017-12-10 20:48:57 UTC
(In reply to Christoph Junghans from comment #8)
> Thanks @Sergey for looking for it! I had a look as well!
> 
> 
> Summary:
> =======
> I found (nitpicks):
> - there are tests in tests/, can we run these in %check?

The tests use Xvrb, and from the looks of it, it requires X running on the box? I can't manage that on the Fedora builders.

> - Can you use install -p to preserve timestamps?

Done.

> and fedora-review found, which is ok already:
> - update-desktop-database is invoked in %post and %postun if package
>   contains desktop file(s) with a MimeType: entry.
>   Note: desktop file(s) with MimeType entry in vimiv
>   See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#desktop-
>   database

Done.

New spec/srpm:
Spec URL: https://ankursinha.fedorapeople.org/vimiv/vimiv.spec
SRPM URL: https://ankursinha.fedorapeople.org/vimiv/vimiv-0.9.1-4.fc27.src.rpm

* Sun Dec 10 2017 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.9.1-4
- Remove tests - Xvfb seems to require root access and X

* Sun Dec 10 2017 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.9.1-3
- Add tests and other corrections based on rhbz #1517006
- update-desktop-database
- preserve timestamps

Cheers!
Ankur

Comment 10 Christoph Junghans 2017-12-11 16:34:02 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #9)
> (In reply to Christoph Junghans from comment #8)
> > Thanks @Sergey for looking for it! I had a look as well!
> > 
> > 
> > Summary:
> > =======
> > I found (nitpicks):
> > - there are tests in tests/, can we run these in %check?
> 
> The tests use Xvrb, and from the looks of it, it requires X running on the
> box? I can't manage that on the Fedora builders.
Thank for the explanation!

> New spec/srpm:
> Spec URL: https://ankursinha.fedorapeople.org/vimiv/vimiv.spec
> SRPM URL:
> https://ankursinha.fedorapeople.org/vimiv/vimiv-0.9.1-4.fc27.src.rpm
> 
> * Sun Dec 10 2017 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.9.1-4
> - Remove tests - Xvfb seems to require root access and X
> 
> * Sun Dec 10 2017 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.9.1-3
> - Add tests and other corrections based on rhbz #1517006
> - update-desktop-database
> - preserve timestamps
> 
> Cheers!
> Ankur
Approved.

Comment 11 Ankur Sinha (FranciscoD) 2017-12-11 21:09:10 UTC
Lovely! Thanks for the review! :)

Comment 12 Gwyn Ciesla 2017-12-11 22:27:51 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/vimiv

Comment 13 Fedora Update System 2017-12-12 13:52:30 UTC
vimiv-0.9.1-4.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-0b7cfb18b1

Comment 14 Fedora Update System 2017-12-12 14:38:28 UTC
vimiv-0.9.1-4.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-dde3662529

Comment 15 Fedora Update System 2017-12-14 06:13:27 UTC
vimiv-0.9.1-4.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-0b7cfb18b1

Comment 16 Fedora Update System 2017-12-14 11:10:22 UTC
vimiv-0.9.1-4.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-dde3662529

Comment 17 Fedora Update System 2017-12-26 16:29:55 UTC
vimiv-0.9.1-4.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2017-12-28 02:48:42 UTC
vimiv-0.9.1-4.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.